
!MAFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 4/19/2009 23:05'!
urlFor: aRenderContext
	"Answer a link to a request handler for the given file."
	
	^ (aRenderContext registry 
		urlForRequestHandler: (MAFileModelHandler on: self))
			displayString! !

!MAFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/26/2009 22:10'!
urlOn: html
	self deprecatedApi: 'Use #urlFor: with the rendering context instead.'.
	^ self urlFor: html context! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/23/2009 22:48'!
defaultSorter
	^ (self description isSortable and: [ self description isRequired ])
		ifTrue: [ super defaultSorter ]! !

!MAInternalEditorComponent methodsFor: 'private' stamp: 'lr 5/17/2009 22:58'!
buildComponent
	^ self value isNil ifFalse: [ 
		(self description reference asComponentOn: self value)
			setParent: self;
			yourself ]! !

WARequestHandler subclass: #MAFileModelHandler
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Core'!

!MAFileModelHandler class methodsFor: 'instance creation' stamp: 'lr 4/19/2009 22:46'!
on: aFileModel
	^ self new initializeOn: aFileModel! !

!MAFileModelHandler methodsFor: 'comparing' stamp: 'lr 4/19/2009 22:47'!
= aHandler
	^ self species = aHandler species and: [ self model = aHandler model ]! !

!MAFileModelHandler methodsFor: 'processing' stamp: 'lr 4/19/2009 23:17'!
handleRequest: aRequest
	| response |
	response := WAResponse new.
	response
		cacheForever;
		contentType: self model mimetype;
		headerAt: 'Content-Disposition' put: 'inline; filename="' , self model filename , '"';
		contents: self model contents readStream.
	^ response! !

!MAFileModelHandler methodsFor: 'comparing' stamp: 'lr 4/19/2009 22:47'!
hash
	^ self model hash! !

!MAFileModelHandler methodsFor: 'initialization' stamp: 'lr 4/19/2009 22:46'!
initializeOn: aFileModel
	model := aFileModel! !

!MAFileModelHandler methodsFor: 'accessing' stamp: 'lr 4/19/2009 22:48'!
model
	^ model! !

!MAReport methodsFor: 'exporting' stamp: 'lr 6/15/2009 20:07'!
exportBodyOn: aStream
	self cache keysAndValuesDo: [ :index :row |
		self visibleColumns
			do: [ :column |
				column
					exportContent: (column valueFor: row)
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream nextPut: Character cr ]! !

!MAReport methodsFor: 'exporting' stamp: 'lr 6/15/2009 20:07'!
exportHeaderOn: aStream
	self visibleColumns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream nextPut: Character cr! !
